#include <C/Common/TRN_RecentlyUsedCache.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <Common/Exception.h>
#include <PDF/BitmapCache/RecentlyUsedCache.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_RecentlyUsedCacheRemoveDocument(TRN_UString document_path)
{
	BEX;
	trn::Common::RecentlyUsedCache::RemoveDocument(UString(document_path));
	EEX;
}

TRN_API TRN_RecentlyUsedCacheAccessDocument(TRN_UString document_path)
{
	BEX;
	trn::Common::RecentlyUsedCache::AccessDocument(UString(document_path));
	EEX;
}

TRN_API TRN_RecentlyUsedCacheGetBitmapPathIfExists(TRN_UString document_path, TRN_UString * result)
{
	BEX;
	RetUStr(trn::Common::RecentlyUsedCache::GetBitmapPathIfExists(UString(document_path)));
	EEX;
}

TRN_API TRN_RecentlyUsedCacheResetCache()
{
	BEX;
	trn::Common::RecentlyUsedCache::ResetCache();
	EEX;
}

TRN_API TRN_RecentlyUsedCacheInitializeRecentlyUsedCache(size_t num_documents, size_t max_absolute_space, double max_percentage_space)
{
	BEX;
	trn::Common::RecentlyUsedCache::InitializeRecentlyUsedCache(num_documents, max_absolute_space, max_percentage_space);
	EEX;
}



