#include <C/PDF/Struct/TRN_ClassMap.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <PDF/Struct/ClassMap.hpp>
#include <C/Common/TRN_Exception.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;
using namespace Struct;

TRN_API TRN_ClassMapCreate(TRN_Obj dict, TRN_ClassMap* result)
{
	BEX;
	*result=(TRN_ClassMap)dict;
    EEX;
}
	
TRN_API TRN_ClassMapCopy (const TRN_ClassMap p, TRN_ClassMap* result)
{
	BEX;
	*result=(TRN_ClassMap)p;
    EEX;
}

TRN_API TRN_ClassMapIsValid(const TRN_ClassMap map, TRN_Bool* result)
{
	BEX;
	*result=BToTB(IMPL_TRN_ClassMapIsValid(CMapCast(map)));
    EEX;
}

TRN_API TRN_ClassMapGetSDFObj (const TRN_ClassMap map, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)map;
    EEX;
}
