#include <C/PDF/Struct/TRN_ContentItem.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/Struct/ContentItem.h>
#include <PDF/Struct/SElement.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace PDF;

TRN_API TRN_ContentItemCopy(const TRN_ContentItem* c, TRN_ContentItem* result)
{
	BEX;
	*result=*c;
	EEX;
}

TRN_API TRN_ContentItemGetType(const TRN_ContentItem* item, enum TRN_ContentItemType* result)
{
	BEX;
	*result=(enum TRN_ContentItemType)CICast(item).GetType();
	EEX;
}

TRN_API TRN_ContentItemGetParent(TRN_ContentItem* item, TRN_SElement* result)
{
	BEX;
    Struct::SElement selement = CICast(item).GetParent();
	*result=RetSEle(selement);
	EEX;
}

TRN_API TRN_ContentItemGetPage(TRN_ContentItem* item, TRN_Page* result)
{
	BEX;
	*result=(TRN_Page)(CICast(item).GetPage().GetSDFObj());
	EEX;
}

TRN_API TRN_ContentItemGetSDFObj (const TRN_ContentItem* item, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)(CICast(item).GetSDFObj());
	EEX;
}

TRN_API TRN_ContentItemGetMCID(const TRN_ContentItem* item, int* result)
{
	BEX;
	*result=CICast(item).GetMCID();
	EEX;
}

TRN_API TRN_ContentItemGetContainingStm(const TRN_ContentItem* item, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)(CICast(item).GetContainingStm());
	EEX;
}

TRN_API TRN_ContentItemGetStmOwner(const TRN_ContentItem* item, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)(CICast(item).GetStmOwner());
	EEX;
}

TRN_API TRN_ContentItemGetRefObj(const TRN_ContentItem* item, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)(CICast(item).GetRefObj());
	EEX;
}
