#include <C/PDF/Struct/TRN_RoleMap.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/Struct/RoleMap.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;
using namespace Struct;


TRN_API TRN_RoleMapCreate (TRN_Obj dict, TRN_RoleMap* result)
{
	BEX;
	*result=(TRN_RoleMap)dict;
	EEX;
}
	
TRN_API TRN_RoleMapCopy (const TRN_RoleMap p, TRN_RoleMap* result)
{
	BEX;
	*result=(TRN_RoleMap)p;
	EEX;
}

TRN_API TRN_RoleMapIsValid(const TRN_RoleMap map, TRN_Bool* result)
{
	BEX;
	*result=BToTB(IMPL_TRN_RoleMapIsValid(RMapCast(map)));
	EEX;
}

TRN_API TRN_RoleMapGetDirectMap(const TRN_RoleMap map, const char* type, const char** result)
{
	BEX;
	*result=IMPL_TRN_RoleMapGetDirectMap(RMapCast(map),type);
	EEX;
}

TRN_API TRN_RoleMapGetSDFObj (const TRN_RoleMap map, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)map;
	EEX;
}
