#include <C/PDF/Struct/TRN_STree.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <PDF/Struct/STree.h>
#include <PDF/Struct/STree.hpp>
#include <C/Common/TRN_Exception.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;
using namespace Struct;


TRN_API TRN_STreeCreate (TRN_Obj struct_dict, TRN_STree* result)
{
	BEX;
	*result=(TRN_STree)struct_dict;
	EEX;
}

TRN_API TRN_STreeCreateFromPDFDoc (TRN_PDFDoc doc, TRN_STree* result)
{
	BEX;
	*result=(TRN_STree)IMPL_TRN_STreeCreate(PDocCast(doc)).GetSDFObj();
	EEX;
}

TRN_API TRN_STreeInsert (TRN_STree tree, TRN_SElement* kid, int insert_before)
{
	BEX;
	IMPL_TRN_STreeInsert(STreeCast(tree), SEleCast(kid), insert_before);
	EEX;
}
	
TRN_API TRN_STreeCopy (const TRN_STree c,TRN_STree* result)
{
	BEX;
	*result=(TRN_STree)c;
	EEX;
}
	
TRN_API TRN_STreeIsValid(const TRN_STree tree, TRN_Bool* result)
{
	BEX;
	*result=BToTB(IMPL_TRN_STreeIsValid(STreeCast(tree)));
	EEX;
}

TRN_API TRN_STreeGetNumKids(TRN_STree tree, int* result)
{
	BEX;
	*result=IMPL_TRN_STreeGetNumKids(STreeCast(tree));
	EEX;
}

TRN_API TRN_STreeGetKid(TRN_STree tree, int index, TRN_SElement* result)
{
	BEX;
    Struct::SElement selement = IMPL_TRN_STreeGetKid(STreeCast(tree),index);
	*result=RetSEle(selement);
	EEX;
}


TRN_API TRN_STreeGetElement(TRN_STree tree, const char* id_buf, int id_buf_sz, TRN_SElement* result)
{
	BEX;
    Struct::SElement selement = IMPL_TRN_STreeGetElement(STreeCast(tree),id_buf,id_buf_sz);
	*result=RetSEle(selement);
	EEX;
}

TRN_API TRN_STreeGetRoleMap(const TRN_STree tree, TRN_RoleMap* result)
{
	BEX;
	*result=(TRN_RoleMap)IMPL_TRN_STreeGetRoleMap(STreeCast(tree));
	EEX;
}

TRN_API TRN_STreeGetClassMap(const TRN_STree tree, TRN_ClassMap* result)
{
	BEX;
	*result=(TRN_ClassMap)IMPL_TRN_STreeGetClassMap(STreeCast(tree));
	EEX;
}

TRN_API TRN_STreeGetSDFObj (const TRN_STree tree, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)tree;
	EEX;
}
