#if defined(_WIN32) && !defined(__WINRT__) && !defined(PDFNET_LEAN)

#include <C/PDF/TRN_PDFDCEX.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/PDFDCEX.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_PDFDCEXCreate (TRN_PDFDCEX *result)
{
	BEX;
	*result = (TRN_PDFDCEX)new trn::PDF::PDFDCEX();
	EEX;
}

TRN_API TRN_PDFDCEXBegin(TRN_PDFDCEX this_pdfDcEx, TRN_PDFDoc in_pdfdoc, const TRN_Point* page_dimension, HDC *result)
{
	BEX;
	*result = (HDC)(PDFDCEXCast(this_pdfDcEx)->Begin(PDocCast(in_pdfdoc), *((const PDF::Point*)page_dimension)));
	EEX;

}

TRN_API TRN_PDFDCEXEnd (TRN_PDFDCEX this_pdfDcEx)
{
	BEX;
	PDFDCEXCast(this_pdfDcEx)->End();	
	EEX;
}

TRN_API TRN_PDFDCEXGetDPI( TRN_PDFDCEX this_pdfDcEx, TRN_UInt32* out_dpi )
{
	BEX;
	*out_dpi = (PDFDCEXCast(this_pdfDcEx)->GetDPI());	
	EEX;
}

TRN_API TRN_PDFDCEXDestroy(TRN_PDFDCEX this_pdfDcEx)
{
	BEX;
	delete (PDFDCEXCast(this_pdfDcEx));
	EEX;
}

#endif // defined(_WIN32) && !defined(__WINRT__) && !defined(PDFNET_LEAN)
