#include <C/PDF/TRN_PDFDocViewPrefs.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/PDFDocViewPrefs.h>
#include <PDF/PDFDocViewPrefs.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;

TRN_API TRN_PDFDocViewPrefsSetInitialPage(TRN_PDFDocViewPrefs p, TRN_Destination dest)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetInitialPage(PDFPrefCast(p),DestCast(dest));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetPageMode(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsPageMode mode)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetPageMode(PDFPrefCast(p),(PDFDocViewPrefs::PageMode)mode);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetPageMode(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsPageMode* result)
{
	BEX;
	*result=(enum TRN_PDFDocViewPrefsPageMode)IMPL_TRN_PDFDocViewPrefsGetPageMode(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetLayoutMode(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsPageLayout mode)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetLayoutMode(PDFPrefCast(p), (PDFDocViewPrefs::PageLayout)mode);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetLayoutMode(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsPageLayout* result)
{
	BEX;
	*result=(enum TRN_PDFDocViewPrefsPageLayout)IMPL_TRN_PDFDocViewPrefsGetLayoutMode(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetPref(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsViewerPref pref, TRN_Bool value)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetPref(PDFPrefCast(p),(PDFDocViewPrefs::ViewerPref)pref,TBToB(value));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetPref(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsViewerPref pref, TRN_Bool* result)
{
	BEX;
	*result=BToTB(IMPL_TRN_PDFDocViewPrefsGetPref(PDFPrefCast(p),(PDFDocViewPrefs::ViewerPref)pref));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetNonFullScreenPageMode(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsPageMode mode)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetNonFullScreenPageMode(PDFPrefCast(p),(PDFDocViewPrefs::PageMode)mode);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetNonFullScreenPageMode(TRN_PDFDocViewPrefs p, enum TRN_PDFDocViewPrefsPageMode* result)
{
	BEX;
	*result=(enum TRN_PDFDocViewPrefsPageMode)IMPL_TRN_PDFDocViewPrefsGetNonFullScreenPageMode(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetDirection(TRN_PDFDocViewPrefs p, TRN_Bool left_to_right)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetDirection(PDFPrefCast(p),TBToB(left_to_right));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetDirection(TRN_PDFDocViewPrefs p, TRN_Bool* result)
{
	BEX;
	*result=BToTB(IMPL_TRN_PDFDocViewPrefsGetDirection(PDFPrefCast(p)));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetViewArea(TRN_PDFDocViewPrefs p, enum TRN_PageBox box)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetViewArea(PDFPrefCast(p),(Page::Box)box);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetViewArea(TRN_PDFDocViewPrefs p, enum TRN_PageBox* result)
{
	BEX;
	*result=(enum TRN_PageBox)IMPL_TRN_PDFDocViewPrefsGetViewArea(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetViewClip(TRN_PDFDocViewPrefs p, enum TRN_PageBox box)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetViewClip(PDFPrefCast(p),(Page::Box)box);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetViewClip(TRN_PDFDocViewPrefs p, enum TRN_PageBox* result)
{
	BEX;
	*result=(enum TRN_PageBox)IMPL_TRN_PDFDocViewPrefsGetViewClip(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetPrintArea(TRN_PDFDocViewPrefs p, enum TRN_PageBox box)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetPrintArea(PDFPrefCast(p),(Page::Box)box);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetPrintArea(TRN_PDFDocViewPrefs p, enum TRN_PageBox* result)
{
	BEX;
	*result=(enum TRN_PageBox)IMPL_TRN_PDFDocViewPrefsGetPrintArea(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsSetPrintClip(TRN_PDFDocViewPrefs p, enum TRN_PageBox box)
{
	BEX;
	IMPL_TRN_PDFDocViewPrefsSetPrintClip(PDFPrefCast(p),(Page::Box)box);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetPrintClip(TRN_PDFDocViewPrefs p, enum TRN_PageBox* result)
{
	BEX;
	*result=(enum TRN_PageBox)IMPL_TRN_PDFDocViewPrefsGetPrintClip(PDFPrefCast(p));
	EEX;
}

TRN_API TRN_PDFDocViewPrefsGetSDFObj(TRN_PDFDocViewPrefs p, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)p;
	EEX;
}


TRN_API TRN_PDFDocViewPrefsCreate (TRN_Obj tr, TRN_PDFDocViewPrefs* result)
{
	BEX;
	*result=(TRN_PDFDocViewPrefs)IMPL_TRN_PDFDocViewPrefsCreate((Obj*)tr);
	EEX;
}

TRN_API TRN_PDFDocViewPrefsCopy (const TRN_PDFDocViewPrefs prefs, TRN_PDFDocViewPrefs* result)
{
	BEX;
	*result=(TRN_PDFDocViewPrefs)prefs;
	EEX;
}
