#include <C/PDF/TRN_Destination.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/Destination.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;

TRN_API TRN_DestinationCreateXYZ(TRN_Page page, double left, double top, double zoom, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateXYZ(PageCast(page),left,top,zoom));
	EEX;
}

TRN_API TRN_DestinationCreateFit(TRN_Page page, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFit(PageCast(page)));
	EEX;
}

TRN_API TRN_DestinationCreateFitH(TRN_Page page, double top, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFitH(PageCast(page),top));
	EEX;
}

TRN_API TRN_DestinationCreateFitV(TRN_Page page, double left, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFitV(PageCast(page),left));
	EEX;
}

TRN_API TRN_DestinationCreateFitR(TRN_Page page, 
								  double left, double bottom,	double right, double top, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFitR(PageCast(page),left,bottom,right,top));
	EEX;
}

TRN_API TRN_DestinationCreateFitB(TRN_Page page, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFitB(PageCast(page)));
	EEX;
}

TRN_API TRN_DestinationCreateFitBH(TRN_Page page, double top, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFitBH(PageCast(page),top));
	EEX;
}

TRN_API TRN_DestinationCreateFitBV(TRN_Page page, double left, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate(IMPL_TRN_DestinationCreateFitBV(PageCast(page),left));
	EEX;
}

TRN_API TRN_DestinationCreate(TRN_Obj dest, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)IMPL_TRN_DestinationCreate((Obj*)dest);
	EEX;
}

TRN_API TRN_DestinationCopy (const TRN_Destination d, TRN_Destination* result)
{
	BEX;
	*result=(TRN_Destination)d;
	EEX;
}

TRN_API TRN_DestinationIsValid(const TRN_Destination dest, TRN_Bool* result)
{
	BEX;
	*result=BToTB(IMPL_TRN_DestinationIsValid(DestCast(dest)));
	EEX;
}

TRN_API TRN_DestinationGetFitType(TRN_Destination dest,enum TRN_DestinationFitType* result)
{
	BEX;
	*result=(enum TRN_DestinationFitType)IMPL_TRN_DestinationGetFitType(DestCast(dest));
	EEX;
}

TRN_API TRN_DestinationGetPage(TRN_Destination dest, TRN_Page* result)
{
	BEX;
	*result=(TRN_Page)IMPL_TRN_DestinationGetPage(DestCast(dest));
	EEX;
}

TRN_API TRN_DestinationSetPage(TRN_Destination dest, TRN_Page page)
{
	BEX;
	IMPL_TRN_DestinationSetPage(DestCast(dest),PageCast(page));
	EEX;
}

TRN_API TRN_DestinationGetSDFObj (const TRN_Destination dest, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)dest;
	EEX;
}

TRN_API TRN_DestinationGetExplicitDestObj (TRN_Destination dest, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)IMPL_TRN_DestinationGetExplicitDestObj(DestCast(dest));
	EEX;
}
