#include <C/PDF/TRN_DocumentPreviewCache.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <Common/Exception.h>
#include <PDF/DocumentPreviewCache.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_DocumentPreviewCacheInitialize(TRN_UInt64 max_cache_bytes, double max_disk_percentage)
{
	BEX;
	trn::PDF::DocumentPreviewCache::Initialize(max_cache_bytes, max_disk_percentage);
	EEX;
}

TRN_API TRN_DocumentPreviewCacheGetBitmapWithPath(TRN_UString document_path, TRN_UInt32 min_x_size, TRN_UInt32 min_y_size, TRN_PreviewHandler proc, void* custom_data)
{
	BEX;
	//[2]
	trn::PDF::DocumentPreviewCache::GetBitmapWithPath(UString(document_path), min_x_size, min_y_size, (trn::PDF::DocumentPreviewCache::PreviewHandler)proc, custom_data);
	EEX;
}

TRN_API TRN_DocumentPreviewCacheCancelAllRequests()
{
	BEX;
	trn::PDF::DocumentPreviewCache::CancelAllRequests();
	EEX;
}

TRN_API TRN_DocumentPreviewCacheCancelRequest(TRN_UString filepath)
{
	BEX;
	trn::PDF::DocumentPreviewCache::CancelRequest(UString(filepath));
	EEX;
}

TRN_API TRN_DocumentPreviewCacheIrrelevantChangeMade(TRN_UString filepath)
{
	BEX;
	trn::PDF::DocumentPreviewCache::IrrelevantChangeMade(UString(filepath));
	EEX;
}

TRN_API TRN_DocumentPreviewCacheClearCache()
{
	BEX;
	trn::PDF::DocumentPreviewCache::ClearCache();
	EEX;
}



