#include <C/PDF/TRN_Function.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/Function.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;

TRN_API TRN_FunctionCreate (TRN_Obj funct_dict, TRN_Function* result)
{
	BEX;
	*result=(TRN_Function)new Function((SDF::Obj*)funct_dict);
	EEX;
}

TRN_API TRN_FunctionAssign(TRN_Function left, TRN_Function right)
{
	BEX;
	FuncCast(left)=FuncCast(right);
	EEX;
}
	
TRN_API TRN_FunctionDestroy(TRN_Function f)
{
	BEX;
	delete (Function*)f;
    EEX;
}

TRN_API TRN_FunctionGetType(const TRN_Function f, enum TRN_FunctionType* result)
{
	BEX;
	*result=(enum TRN_FunctionType)FuncCast(f).GetType();
	EEX;
}


TRN_API TRN_FunctionGetInputCardinality(TRN_Function f, int* result)
{
	BEX;
	*result=FuncCast(f).GetInputCardinality();
    EEX;
}

TRN_API TRN_FunctionGetOutputCardinality(TRN_Function f, int* result)
{
	BEX;
	*result=FuncCast(f).GetOutputCardinality();
	EEX;
}

TRN_API TRN_FunctionEval(TRN_Function f, double *inval, double *outval)
{
	BEX;
	FuncCast(f).Eval(inval,outval);
	EEX;
}

TRN_API TRN_FunctionGetSDFObj (TRN_Function f, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)FuncCast(f).GetSDFObj();
	EEX;
}
