#include <C/PDF/TRN_Highlights.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/Highlights.hpp>
#include <SDF/License.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;

TRN_API TRN_HighlightsCreate(TRN_Highlights* result)
{
	BEX;
	*result=(TRN_Highlights)new Highlights();
	EEX;
}

TRN_API TRN_HighlightsDestroy(TRN_Highlights hlts)
{
	BEX;
	delete (Highlights*)hlts;
	EEX;
}

TRN_API TRN_HighlightsCopyCtor(TRN_Highlights hlts, TRN_Highlights* result)
{
	BEX;
	*result=(TRN_Highlights)new Highlights( *((Highlights*)hlts) );
	EEX;
}

TRN_API TRN_HighlightsAssign(TRN_Highlights result, TRN_Highlights hlts)
{
	BEX;
	*(Highlights*)result = *(Highlights*)hlts;
	EEX;
}

TRN_API TRN_HighlightsAdd(TRN_Highlights hlts2, TRN_Highlights hlts)
{
	BEX;
	HLCast(hlts2).Add(HLCast(hlts));
	EEX;
}

TRN_API TRN_HighlightsLoad(TRN_Highlights hlts, TRN_UString file_name)
{
	BEX;
	UString temp(UStrCast(file_name));
	HLCast(hlts).Load(temp);
	EEX;
}

TRN_API TRN_HighlightsSave(TRN_Highlights hlts, TRN_UString file_name)
{
	BEX;
	UString temp(UStrCast(file_name));
	HLCast(hlts).Save(temp);
	EEX;
}

TRN_API TRN_HighlightsClear(TRN_Highlights hlts)
{
	BEX;
	HLCast(hlts).Clear();
	EEX;
}

TRN_API TRN_HighlightsBegin(TRN_Highlights hlts, TRN_PDFDoc doc)
{
	BEX;
	HLCast(hlts).Begin(PDocCast(doc));
	EEX;
}

TRN_API TRN_HighlightsHasNext(TRN_Highlights hlts, TRN_Bool* result)
{
	BEX;
	*result = BToTB(HLCast(hlts).HasNext());
	EEX;
}

TRN_API TRN_HighlightsNext(TRN_Highlights hlts)
{
	BEX;
	HLCast(hlts).Next();
	EEX;
}

TRN_API TRN_HighlightsGetCurrentPageNumber(TRN_Highlights hlts, int* result)
{
	BEX;
	*result = HLCast(hlts).GetCurrentPageNumber();
	EEX;
}


TRN_API TRN_HighlightsGetCurrentQuads(TRN_Highlights hlts, const double** quads, int* result)
{
	BEX;
	*result = HLCast(hlts).GetCurrentQuads(*quads);
	EEX;
}

