#include <C/PDF/TRN_RadioButtonGroup.h>
#include <C/Common/TRN_Exception.hpp>
#include <PDF/Annots/RadioButtonGroup.h>

using namespace trn;
using namespace PDF;
using namespace Annots;

TRN_API TRN_RadioButtonGroupCreateFromField(const TRN_Field* field, TRN_RadioButtonGroup* result)
{
	BEX;
	*result = (TRN_RadioButtonGroup) new RadioButtonGroup(FieldCast(field));
	EEX;
}

TRN_API TRN_RadioButtonGroupCreate(TRN_PDFDoc doc, TRN_UString field_name, TRN_RadioButtonGroup* result)
{
	BEX;
	*result = (TRN_RadioButtonGroup) new RadioButtonGroup(RadioButtonGroup::Create(*PDocCast(doc), UString(field_name)));
	EEX;
}

TRN_API TRN_RadioButtonGroupCopy(TRN_RadioButtonGroup group, TRN_RadioButtonGroup* result)
{
	BEX;
	*result = (TRN_RadioButtonGroup) new RadioButtonGroup(*(RadioButtonGroup*)group);
	EEX;
}

TRN_API TRN_RadioButtonGroupAssign(TRN_RadioButtonGroup left, TRN_RadioButtonGroup right)
{
	BEX;
	*(RadioButtonGroup*)(left) = *(RadioButtonGroup*)(right);
	EEX;
}


TRN_API TRN_RadioButtonGroupDestroy(TRN_RadioButtonGroup group)
{
	BEX;
	delete (RadioButtonGroup*)group;
	EEX;
}

TRN_API TRN_RadioButtonGroupAdd(TRN_RadioButtonGroup group, const TRN_Rect* pos, const char* onstate, TRN_RadioButtonWidget* result)
{
	BEX;
	*result = (TRN_RadioButtonWidget)((RadioButtonGroup*)group)->Add(RectCast(pos), onstate).GetSDFObj();
	EEX;
}

TRN_API TRN_RadioButtonGroupGetNumButtons(TRN_RadioButtonGroup group, TRN_UInt32* result)
{
	BEX;
	*result = ((RadioButtonGroup*)group)->GetNumButtons();
	EEX;
}

TRN_API TRN_RadioButtonGroupGetButton(TRN_RadioButtonGroup group, TRN_UInt32 index, TRN_RadioButtonWidget* result)
{
	BEX;
	*result = (TRN_RadioButtonWidget) ((RadioButtonGroup*)group)->GetButton(index).GetSDFObj();
	EEX;
}

TRN_API TRN_RadioButtonGroupGetField(TRN_RadioButtonGroup group, TRN_Field* result)
{
	BEX;
	Field f = ((RadioButtonGroup*)group)->GetField();
	*result = RetField(f);
	EEX;
}

TRN_API TRN_RadioButtonGroupAddGroupButtonsToPage(TRN_RadioButtonGroup group, TRN_Page page)
{
	BEX;
	Page p(PageCast(page));
	((RadioButtonGroup*)group)->AddGroupButtonsToPage(p);
	EEX;
}

