//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#include <C/PDF/TRN_ReflowProcessor.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <Common/Exception.h>
#include <Convert/Reflow/ReflowProcessor.hpp>
#include <PDF/JobRequest.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_ReflowProcessorInitialize()
{
	BEX;
	trn::PDF::ReflowProcessor::Initialize();
	EEX;
}

TRN_API TRN_ReflowProcessorIsInitialized(TRN_Bool* result)
{
	BEX;
	*result = BToTB(trn::PDF::ReflowProcessor::IsInitialized());
	EEX;
}

TRN_API TRN_ReflowProcessorGetReflow(const TRN_Page page, TRN_ProcHandler proc, void * custom_data)
{
	BEX;
	trn::PDF::ReflowProcessor::GetReflow(PageCast(page), (trn::PDF::JobRequest::ProcHandler)proc, custom_data);
	EEX;
}

TRN_API TRN_ReflowProcessorCancelAllRequests()
{
	BEX;
	trn::PDF::ReflowProcessor::CancelAllRequests();
	EEX;
}

TRN_API TRN_ReflowProcessorCancelRequest(const TRN_Page page)
{
	BEX;
	trn::PDF::ReflowProcessor::CancelRequest(PageCast(page));
	EEX;
}

TRN_API TRN_ReflowProcessorClearCache()
{
	BEX;
	trn::PDF::ReflowProcessor::ClearCache();
	EEX;
}


TRN_API TRN_SetNoReflowContent(TRN_UString content)
{
	BEX;
	UString content_str(content);
	trn::PDF::ReflowProcessor::SetNoReflowContent(content_str);
	EEX;
}


TRN_API TRN_SetReflowFailedContent(TRN_UString content)
{
	BEX;
	UString content_str(content);
	trn::PDF::ReflowProcessor::SetReflowFailedContent(content_str);
	EEX;
}


