#include <C/Common/TRN_Types.h>
#include <C/PDF/TRN_Optimizer.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <boost/static_assert.hpp>
#include <C/Common/TRN_Exception.hpp>
#include <PDF/TextExtractor.h>
#include <PDF/Struct/ContentItem.h>
#include <PDF/Date.h>
#include <PDF/QuadPoint.h>
#include <PDF/ColorSpace.h>
#include <PDF/PageLabel.h>
#include <PDF/PDFView.h>
#include <PDF/CharIterator.h>
#include <PDF/Optimizer.hpp>

#include <C/PDF/PDFA/TRN_PDFACompliance.h>

using namespace PDF;

// These do not appear to have an equivalent class in the core
/*
typedef TRN_SecurityHandler (*TRN_PDFNetCreateSecurityHandler) (const char* name, int key_len, int enc_code);
struct TRN_sechdlrinfo
{
	const char* m_name;
	const char* m_gui_name;
	TRN_PDFNetCreateSecurityHandler m_factory_method;
};
typedef struct TRN_sechdlrinfo TRN_SecHdlrInfo;


struct TRN_objpair
{
	TRN_Obj key;
	TRN_Obj value;
};
typedef struct TRN_objpair TRN_ObjPair;*/

BOOST_STATIC_ASSERT(sizeof(TRN_Matrix2D)==sizeof(Common::Matrix2D));
BOOST_STATIC_ASSERT(sizeof(TRN_ColorPt)==sizeof(ColorPt));
BOOST_STATIC_ASSERT(sizeof(TRN_Rect)==sizeof(Rect));
BOOST_STATIC_ASSERT(sizeof(TRN_Date)==sizeof(Date));
BOOST_STATIC_ASSERT(sizeof(TRN_PageLabel)==sizeof(PageLabel));
BOOST_STATIC_ASSERT(sizeof(TRN_CharData)==sizeof(CharData));
BOOST_STATIC_ASSERT(sizeof(TRN_Field)==sizeof(Field));
BOOST_STATIC_ASSERT(sizeof(TRN_ContentItem)==sizeof(Struct::ContentItem));
BOOST_STATIC_ASSERT(sizeof(TRN_SElement)==sizeof(Struct::SElement));
BOOST_STATIC_ASSERT(sizeof(TRN_FDFField)==sizeof(FDF::FDFField));
BOOST_STATIC_ASSERT(sizeof(TRN_Point)==sizeof(Point));
BOOST_STATIC_ASSERT(sizeof(TRN_QuadPoint)==sizeof(QuadPoint));
BOOST_STATIC_ASSERT(sizeof(TRN_TextExtractorStyle)==sizeof(TextExtractor::Style));
BOOST_STATIC_ASSERT(sizeof(TRN_TextExtractorLine)==sizeof(TextExtractor::Line));
BOOST_STATIC_ASSERT(sizeof(TRN_TextExtractorWord)==sizeof(TextExtractor::Word));
BOOST_STATIC_ASSERT(sizeof(TRN_OptimizerImageSettings)==sizeof(Optimizer::ImageSettings));
BOOST_STATIC_ASSERT(sizeof(TRN_OptimizerMonoImageSettings)==sizeof(Optimizer::MonoImageSettings));
BOOST_STATIC_ASSERT(sizeof(TRN_OptimizerTextSettings)==sizeof(Optimizer::TextSettings));
BOOST_STATIC_ASSERT(sizeof(TRN_PDFDoc)==sizeof(PDFDoc));

#if defined(__PNACL__ )|| defined(EMSCRIPTEN)
BOOST_STATIC_ASSERT(sizeof(enum TRN_PDFAComplianceConformance) == 4);
#endif

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
