#include <C/Common/TRN_Vector.h>
#include <C/Common/TRN_API_Config.hpp>
#include <C/Common/TRN_PolymorphicVector.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <C/Common/TRN_UString.h>
#include <Common/FlexVector.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_VectorGetSize(TRN_Vector vec, TRN_UInt32* result)
{
	BEX;
	*result = ((PolyVector*)vec)->GetSize();
	EEX;
}

TRN_API TRN_VectorGetData(TRN_Vector vec, void** result)
{
	BEX
	*result = ((PolyVector*)vec)->GetData();
	EEX;
}

TRN_API TRN_VectorGetAt(TRN_Vector vec, TRN_UInt32 pos, void** result)
{
	BEX;
	*result = ((PolyVector*)vec)->GetAt(pos);
	EEX;
}

TRN_API TRN_VectorDestroy(TRN_Vector vec)
{
	BEX;
	((PolyVector*)vec)->DestroyContents();
	delete (PolyVector*)vec;
	EEX;
}

TRN_API TRN_VectorDestroyKeepContents(TRN_Vector vec)
{
	BEX;
	delete (PolyVector*)vec;
	EEX;
}
