#include <C/FDF/TRN_FDFField.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <FDF/FDFField.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace FDF;
using namespace SDF;

TRN_API TRN_FDFFieldCreate (TRN_Obj field_dict, TRN_Obj fdf_dict, TRN_FDFField* result)
{
	BEX;
	const trn::FDF::FDFField &r = FDFField(ObjCast(field_dict),ObjCast(fdf_dict));
	*result = *((TRN_FDFField*)&r);
	EEX;
}

TRN_API TRN_FDFFieldAssign (TRN_FDFField* left, const TRN_FDFField* right)
{
	BEX;
	FFieldCast(left)=FFieldCast(right);
	EEX;
}

TRN_API TRN_FDFFieldGetValue(TRN_FDFField* field, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)FFieldCast(field).GetValue();
	EEX;
}

TRN_API TRN_FDFFieldSetValue(TRN_FDFField* field, TRN_Obj value)
{
	BEX;
	FFieldCast(field).SetValue(ObjCast(value));
	EEX;
}

TRN_API TRN_FDFFieldGetName(TRN_FDFField* field, TRN_UString* result)
{
	BEX;
	RetUStr(FFieldCast(field).GetName());
	EEX;
}

TRN_API TRN_FDFFieldGetPartialName(TRN_FDFField* field, TRN_UString* result)
{
	BEX;
	RetUStr(FFieldCast(field).GetPartialName());
	EEX;
}

TRN_API TRN_FDFFieldGetSDFObj(const TRN_FDFField* field, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)FFieldCast(field).GetSDFObj();
	EEX;
}

TRN_API TRN_FDFFieldFindAttribute (const TRN_FDFField* field, const char* attrib, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)FFieldCast(field).FindAttribute(attrib);
	EEX;
}
