#include <C/PDF/Struct/TRN_AttrObj.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/Struct/AttrObj.hpp>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;
using namespace Struct;

TRN_API TRN_AttrObjCreate (TRN_Obj dict, TRN_AttrObj* result)
{
	BEX;
	*result=(TRN_AttrObj)dict;
	EEX;
}
	
TRN_API TRN_AttrObjCopy (const TRN_AttrObj a, TRN_AttrObj* result)
{
	BEX;
	*result=(TRN_AttrObj)a;
	EEX;
}

TRN_API TRN_AttrObjGetOwner(const TRN_AttrObj obj, const char** result)
{
	BEX;
	*result=IMPL_TRN_AttrObjGetOwner((Obj*)obj);
	EEX;
}

TRN_API TRN_AttrObjGetSDFObj (const TRN_AttrObj obj, TRN_Obj* result)
{
	BEX;
	*result=(TRN_Obj)obj;
	EEX;
}
