#include <C/PDF/TRN_ContentReplacer.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <vector>
#include <C/Common/TRN_Exception.hpp>
#include <PDF/ContentReplacer.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;

TRN_API TRN_ContentReplacerCreate(TRN_ContentReplacer* result)
{
	BEX;
	*result=(TRN_ContentReplacer)new PDF::ContentReplacer();
	EEX;
}

TRN_API TRN_ContentReplacerDestroy(TRN_ContentReplacer cr)
{
	BEX;
	delete (PDF::ContentReplacer*)cr;
	EEX;
}

TRN_API TRN_ContentReplacer_AddImage(TRN_ContentReplacer cr, const TRN_Rect* target_region, TRN_Obj replacement_image)
{
	BEX;
	PDF::ContentReplacer::ImageRect ir(RectCast(target_region), ObjCast(replacement_image));
	ContRepCast(cr).image.push_back(ir);
	EEX;
}

TRN_API TRN_ContentReplacer_AddText(TRN_ContentReplacer cr, const TRN_Rect* target_region, const TRN_UString replacement_text)
{
	BEX;
	UString temp(UStrCast(replacement_text));
	PDF::ContentReplacer::TextRect tr(RectCast(target_region), temp);
	ContRepCast(cr).text.push_back(tr);
	EEX;
}

TRN_API TRN_ContentReplacer_AddString(TRN_ContentReplacer cr, const TRN_UString template_text, const TRN_UString replacement_text)
{
	BEX;
	UString k(UStrCast(template_text));
	UString v(UStrCast(replacement_text));
	ContRepCast(cr).placeholder_text[k] = v;
	EEX;
}

TRN_API TRN_ContentReplacer_SetMatchStrings(TRN_ContentReplacer cr, const TRN_UString start_str, const TRN_UString end_str)
{
	BEX;
	UString start_str_temp(UStrCast(start_str));
	UString end_str_temp(UStrCast(end_str));
	ContRepCast(cr).SetMatchStrings(start_str_temp, end_str_temp);
	EEX;
}

TRN_API TRN_ContentReplacer_Process(TRN_ContentReplacer cr, TRN_Page page)
{
	BEX;
	Page temp(PageCast(page));
	ContRepCast(cr).Process(temp);
	EEX;
}
