#if defined(_WIN32) && !defined(__WINRT__) && !defined(PDFNET_LEAN)

#include <C/PDF/TRN_PDFDC.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <PDF/PDFDC.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_PDFDcCreate (TRN_PDFDC *result)
{
	BEX;
	*result = (TRN_PDFDC)new trn::PDF::PDFDC();
	EEX;
}

TRN_API TRN_PDFDcBegin (TRN_PDFDC this_pdfdc, TRN_Page in_pdfpage, const TRN_Rect in_bbox, TRN_Bool in_preserveAspectRatio, HDC *result )
{
	BEX;
	PDF::Page p(PageCast(in_pdfpage));  // TODO exception to CWraping rules
	*result = (HDC)(PDFDcCast(this_pdfdc)->Begin(p, *((const PDF::Rect*)(&in_bbox)), (in_preserveAspectRatio!=0) ));	
	EEX;
}

TRN_API TRN_PDFDcEnd (TRN_PDFDC this_pdfdc)
{
	BEX;
	PDFDcCast(this_pdfdc)->End();	
	EEX;
}

TRN_API TRN_PDFDcSetDPI (TRN_PDFDC this_pdfdc, const TRN_UInt32 in_dpi )
{
	BEX;
	(PDFDcCast(this_pdfdc)->SetDPI(in_dpi));	
	EEX;
}

TRN_API TRN_PDFDcDestroy(TRN_PDFDC this_pdfdc)
{
	BEX;
	delete (PDFDcCast(this_pdfdc));
	EEX;
}

#endif // defined(_WIN32) && !defined(__WINRT__) && !defined(PDFNET_LEAN)
