#include <C/PDF/TRN_Print.h>
#include <C/Common/TRN_API_Config.hpp>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <C/Common/TRN_Exception.hpp>
#include <Convert/Print/Print.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

using namespace SDF;
using namespace PDF;

TRN_API TRN_PrintStartPrintJob(TRN_PDFDoc in_pdfdoc, 
				  TRN_UString in_printerName, 
				  TRN_UString in_jobname, 
				  TRN_UString in_outputFileName, 
				  TRN_PageSet in_pagesToPrint,
				  TRN_Obj in_printerMode, 
				  volatile TRN_Bool * in_cancel,
				  TRN_OCGContext in_ctx)
{
	BEX;
	UString printerName(in_printerName);
	UString jobname(in_jobname);
	UString outputFileName(in_outputFileName);
#if defined(_WIN32)
	PDF::Print::StartPrintJob(
		*((PDFDoc *)(&in_pdfdoc)), 
		printerName, 
		jobname, 
		outputFileName, 
		(PageSet *) in_pagesToPrint, 
		ObjCast(in_printerMode),
        (volatile bool *) in_cancel,
		NULL, // DEVMODE
		(trn::PDF::OCG::Context *) in_ctx);	
#else
	BASE_ASSERT(false, "Printing not supported on this platform");
#endif // defined(_WIN32)
	EEX;
}
