//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#include <C/PDF/TRN_TrustVerificationResult.h>
#include <C/Common/TRN_API_Config.hpp>
#include <C/Common/TRN_Exception.hpp>
#include <C/PDF/TRN_CertificateStatus.h>

// All C++ standard library and internal header files must be inside these guards.
// C standard header files (e.g. stdio.h) are recommended to be outside of these guards.
#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility push(hidden)
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

#include <PDF/iTrustVerificationResult.hpp>
#include <C/Common/TRN_PolymorphicVector.hpp>
#include <C/Common/TRN_Vector.h>

#if TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES
#pragma GCC visibility pop
#endif // TRN_ENABLE_HIDE_SYMBOL_DIRECTIVES

TRN_API TRN_TrustVerificationResultWasSuccessful(TRN_TrustVerificationResult self, TRN_Bool* result)
{
	BEX;
	*result = ((trn::PDF::iTrustVerificationResult*)self )->WasSuccessful();
	EEX;
}


TRN_API TRN_TrustVerificationResultGetResultString(TRN_TrustVerificationResult self, TRN_UString* result)
{
	BEX;
	*result = ExtractTRNUStringCodegen(((trn::PDF::iTrustVerificationResult*)self )->GetResultString());
	EEX;
}


TRN_API TRN_TrustVerificationResultGetTimeOfTrustVerification(TRN_TrustVerificationResult self, TRN_Int64* result)
{
	BEX;
	*result = static_cast<TRN_Int64>(((trn::PDF::iTrustVerificationResult*)self )->GetTimeOfTrustVerification());
	EEX;
}


TRN_API TRN_TrustVerificationResultGetTimeOfTrustVerificationEnum(TRN_TrustVerificationResult self, enum TRN_VerificationOptions_TimeMode* result)
{
	BEX;
	*(trn::UInt32*)result = (TRN_VerificationOptions_TimeMode)((trn::PDF::iTrustVerificationResult*)self)->GetTimeOfTrustVerificationEnum();
	EEX;
}

TRN_API TRN_TrustVerificationResultDestroy(TRN_TrustVerificationResult self)
{
	BEX;
	if(self)
	{
		((trn::PDF::iTrustVerificationResult*)(self))->RemoveReference();
	}
	EEX;
}
