//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#import "PTAnnotStyleTableViewItem.h"
#import "PTMeasurementScale.h"

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@class PTAnnotStylePrecisionTableViewCell;

@protocol PTAnnotStylePrecisionTableViewCellDelegate <NSObject>

- (void)stylePrecisionTableViewCell:(PTAnnotStylePrecisionTableViewCell *)cell measurementScaleDidChange:(PTMeasurementScale *)measurementScale;

@end

@interface PTAnnotStylePrecisionTableViewCell : UITableViewCell

@property (nonatomic, strong) PTMeasurementScale *measurementScale;

@property (nonatomic, strong) UILabel *label;

@property (nonatomic, strong) UILabel *precisionLabel;

@property (nonatomic, weak, nullable) id<PTAnnotStylePrecisionTableViewCellDelegate> delegate;

- (void)configureWithItem:(PTAnnotStylePrecisionTableViewItem *)item;

@end

NS_ASSUME_NONNULL_END
