//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#import "PTTool.h"
#import "ToolsDefines.h"
#import "PTDigSigViewController.h"
#import "PTFloatingSigViewController.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Handles creation of signatures and digitally signing documents.
 */
@interface PTDigitalSignatureTool : PTTool <PTDigSigViewControllerDelegate, PTFloatingSigViewControllerDelegate>


@property (nonatomic, assign) BOOL showDefaultSignature PT_DEPRECATED_MSG(7.1.0, "Use showsSavedSignatures");

/**
* Whether the controller shows a list of saved signatures. The default value of this property is `YES`.
*/
@property (nonatomic, assign) BOOL showsSavedSignatures;

@end

NS_ASSUME_NONNULL_END
