//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#import "PTCategoryDefines.h"

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface NSObject (PTAdditions)

+ (nullable instancetype)pt_castAsKindFromObject:(nullable id)object;

+ (nullable instancetype)pt_castAsMemberFromObject:(nullable id)object;

/**
 * Returns the names of all properties whose class is a subclass of, or identical to, a given class.
 *
 * @param aClass A class object
 *
 * @return the names of all properties whose class is a subclass of, or identical to, `aClass`
 */
+ (NSSet<NSString *> *)pt_propertyNamesForKindOfClass:(Class)aClass;

@end

NS_ASSUME_NONNULL_END

PT_DECLARE_CATEGORY_SYMBOL(NSObject, PTAdditions)
PT_IMPORT_CATEGORY(NSObject, PTAdditions)
