//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#import "ToolsConfig.h"
#import "NSString+PTAdditions.h"

@implementation NSString (PTAdditions)

NSString * const PTKeyPathSeparator = @".";

- (NSString *)pt_sentenceCapitalizedString
{
    if (self.length < 1) {
        return self;
    }
    
    return [[self substringToIndex:1].capitalizedString stringByAppendingString:[self substringFromIndex:1]];
}

- (NSArray<NSString *> *)pt_keyPathComponents
{
    return [self componentsSeparatedByString:PTKeyPathSeparator];
}

@end

PT_DEFINE_CATEGORY_SYMBOL(NSString, PTAdditions)
