//---------------------------------------------------------------------------------------
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
// Consult legal.txt regarding legal and license information.
//---------------------------------------------------------------------------------------

#import "ToolsConfig.h"
#import "UIView+PTAdditions.h"

@implementation UIView (PTAdditions)

- (UIViewController *)pt_viewController
{
    UIViewController *viewController = nil;
    
    // Walk up the responder chain to find the closest view controller.
    for (UIResponder *responder = self.nextResponder; responder; responder = responder.nextResponder) {
        if ([responder isKindOfClass:[UIViewController class]]) {
            viewController = (UIViewController *)responder;
            break;
        }
    }
    
    if (viewController) {
        return viewController;
    }
    
    // Find the top presented view controller.
    UIViewController *topController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    while (topController.presentedViewController) {
        topController = topController.presentedViewController;
    }
    
    return topController;
}

@end

PT_DEFINE_CATEGORY_SYMBOL(UIView, PTAdditions)
