## iOS Documentation

* [PDFTron for iOS Guides](https://www.pdftron.com/documentation/ios/get-started) &ndash; Guides to help with using PDFTron for iOS.

#About the PDFTron SDK

The PDFTron SDK is a high-quality, industry-strength PDF library meeting the requirements of the most demanding and diverse applications. Using PDFTron you can write stand-alone, cross-platform, and reliable commercial applications that can read, write, edit, print and display PDF documents. 

The PDFTron SDK is available for all major mobile platforms:
  
* [Android](https://www.pdftron.com/pdf-sdk/android) (Java, C/C++, Xamarin)
* [iOS](https://www.pdftron.com/pdf-sdk/ios) (Obj-C, Swift, C/C++, Xamarin)
* [Universal Windows Platform (UWP)](https://www.pdftron.com/pdf-sdk/uwp-library) (C#, VB, C++, JavaScript)
* [Xamarin](https://www.pdftron.com/pdf-sdk/xamarin-library) (C#)

and desktop/server environments:

* [Windows](https://www.pdftron.com/pdf-sdk/windows-library) (.NET 2.0-UWP, Java, C/C++, Python)
* [Linux](https://www.pdftron.com/pdf-sdk/linux-tools) (Java, C/C++, Python, Ruby)
* [macOS](https://www.pdftron.com/pdf-sdk/mac-library) (Obj-C, Swift, Java, C/C++, Python, Ruby)

as well as, with [WebViewer](https://www.pdftron.com/webviewer), directly in a web browser.

For more information, please visit us at [www.pdftron.com](https://www.pdftron.com/).

##PDFTron for iOS SDK Overview

* **Doc** &ndash; A folder containing the PDFTron API Reference, in HTML format and as a .docset.
* **Lib** &ndash; A folder containing the PDFTron framework (dynamic and static variants), and the Tools framework and associated source code.
* **Samples** &ndash; A folder containing iOS sample projects.
* **TestFiles** &ndash; PDF test files used by the sample projects.
* **legal.txt** &ndash; Legal and copyright information.
* **license.pdf** &ndash; CPU license agreement and warranty for this product.
* **readme.{md,html}** &ndash; This file in html and markdown.

##Additional iOS Documentation

* [Release Notes](https://www.pdftron.com/documentation/ios/changelog) &ndash; Library release history
* [Cross-plaform samples](https://www.pdftron.com/documentation/samples?platforms=ios) &ndash; Swift and Obj-C versions of our programmatic sample sample code. (The iOS .dmg download contains a number of separate iOS specific interactive sample projects.)
* [PDFTron Knowledge Base](http://groups.google.com/group/pdfnet-sdk) &ndash; A searchable database of PDFTron questions and answers.

##Adding PDFTron to an iOS App

###New project tutorial

The online [how to integrate PDFTron on iOS](https://www.pdftron.com/documentation/ios/get-started/integration/cocoapods/) is a step-by-step tutorial for adding PDFTron to an Xcode project.

##Technical Support

At PDFTron, we understand that good technical support is as important to our customers as our products themselves. Our technical support team consists of the same developers that build our products, work on new features and fix the bugs. This ensures that our customers receive accurate and to-the- point answers to their questions or problems.

For details related to technical support, please refer to [PDFTron support](page: http://www.pdftron.com/support.html) 

You can submit bug reports directly through our [support webpage](https://www.pdftron.com/support).

Thank you!


Copyright &copy; 2001-2020 by PDFTron Systems, Inc. All Rights Reserved. PDFTron, PDFNet SDK and PDF CosEdit are either trademarks and/or service marks and/or registered trademarks of PDFTron Systems Incorporated in Canada, United States and/or other countries.
